﻿using System.Collections;
using System.Windows.Forms;

namespace GearHeadSaveDataViewer
{
	public sealed class ListViewItemComparer : IComparer
	{
		public int Column { get; set; }
		public SortOrder Sorting { get; set; }

		public ListViewItemComparer(SortOrder order)
		{
			this.Column = 0;
			this.Sorting = order;
		}

		public int Compare(object x, object y)
		{
			string sx = ((ListViewItem)x).SubItems[this.Column].Text, sy = ((ListViewItem)y).SubItems[this.Column].Text;
			if (string.IsNullOrEmpty(sx))
			{
				if (string.IsNullOrEmpty(sy))
				{
					return 0;
				}
				return sy.Length;
			}
			else if (string.IsNullOrEmpty(sy))
			{
				return -sx.Length;
			}
			if (this.Sorting == SortOrder.Ascending)
			{
				return string.Compare(sx, sy, true);
			}
			else if (this.Sorting == SortOrder.Descending)
			{
				return -string.Compare(sx, sy, true);
			}
			return 0;
		}
	}
}
